import tkinter 
import random
import time
# time.sleep(0.1)

bx=10  # ボール ( bx:100--1180)
by=690
mx=300      # ラケット１ mx()    
my=550      #            my()
nx=900      # ラケット２ nx()
ny=400      #            ny()
key=""
index=0
tmr=0
a=32     # 放物線
b=440
c=30
point=0
jun=0
p1=0
p2=0
x1=0
    
def key_down(e):        # Key Down
    global key
    key=e.keysym
def key_up(e):          # Key Up
    global key
    key=""

def key_in1():          # 放物線の a,b
    global a,b,key
    if key == "a" and b>=345:
        b=b-10
    if key == "d" and b<=535:
        b=b+10
    if key == "w" and a>=23:
        a=a-2
    if key == "s" and a<=41:
        a=a+2
    cvs.delete("KEISUU")
    draw_text("a="+str(a)+" ＜ W ⋂ S ＞ (22--42)",195,20,25,"yellow","KEISUU")
    draw_text("b="+str(b)+" ＜ A ← → D ＞ (340--540)",245,50,25,"yellow","KEISUU")
    draw_text("Start: space key",130,80,20,"red","KEISUU") 
        
def key_in2():          # ラケット２の移動
    global nx,ny,key
    if key == "Left" and nx>=600:
        nx=nx-6
    if key == "Right" and nx<=1160:
        nx=nx+6
    if key == "Up" and ny>=150:
        ny=ny-8
    if key == "Down" and ny<=680:
        ny=ny+10

def draw_point():
    global p1,p2
    draw_text("A "+str(p1)+" -- "+str(p2)+" B",1000,40,40,"yellow","pt")

def draw_rakt1():        # ラケット１の描画
    global mx,my
    cvs.create_rectangle(mx-30,my-10,mx+30,my+10,fill="silver",tag="RACKET1")

def draw_rakt2():        # ラケット２の描画
    global nx,ny
    cvs.create_rectangle(nx-30,ny-10,nx+30,ny+10,fill="silver",tag="RACKET2")    

def draw_ball():        # ボールの描画
    global bx,by
    cvs.create_oval(bx-10,by-10,bx+10,by+10,fill="red",width=1,tag="BALL")
    
def draw_text(txt,x,y,siz,col,tg):      # テキスト表示（影付き）
    fnt=("Times New Roman",siz,"bold")
    cvs.create_text(x+3,y+3,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)    


def main_proc(): # ====================================================================
    global bx,by,tmr,index,a,b,c,nx,ny,point,p1,p2,jun,x1
    if index==0:
        tmr=0
        cvs.create_rectangle(100,685,400,700,fill="white",tag="MATO")
        cvs.create_rectangle(150,685,350,697,fill="cyan",tag="MATO")
        cvs.create_rectangle(190,685,310,694,fill="blue",tag="MATO")
        cvs.create_rectangle(230,685,270,691,fill="gold",tag="MATO")
        cvs.delete("POINT")
        cvs.delete("pt")
        draw_point()
        nx=900      # ラケット２ nx()
        ny=400      #            ny()
        point=0
        a=32
        b=440
        bx=10
        by=690
        draw_ball()
        draw_rakt2()
        cvs.delete("LINE")
        if jun==0:
            cvs.create_rectangle(850,70,980,75,fill="silver",tag="LINE")
        else:
            cvs.create_rectangle(1020,70,1150,75,fill="silver",tag="LINE")
        index=1
    elif index==1:
        if tmr==10:
            tmr=0
            key_in1()
        if key=="space":
            a=a/10000     # 0.0045        
            tmr=0
            index=2
    elif index==2:
        cvs.delete("KEISUU")
        draw_text("y="+str(a)+"(x-"+str(b)+")^2+"+str(c),190,30,28,"yellow","SIKI")
        cvs.delete("BALL")
        if tmr==100:
            tmr=0                                                 # スタート   
            index=3
    elif index==3:  # --- ボールの動き --------------------------
        if tmr==1:      # tmr=1 => index=4      描いてから消えるまでの時間     
            index=4
    elif index==4:
        cvs.delete("BALL")
        bx=bx+5
        by=a*(bx-b)*(bx-b)+30
        draw_ball()
        cvs.delete("RACKET2")
        key_in2()
        draw_rakt2()
        if bx>nx-30 and bx<nx+30 and by>ny-10 and by<ny:
            b=2*bx-b
        if bx==1190:        # 右の壁
            b=2380-b
            tmr=0
            index=5
        else:
            tmr=0
            index=3
        if by>=1200:        # 打ち損ない、底を突破
            tmr=0
            index=7
        tmr=0
        
    elif index==5:
        if tmr==1:
            index=6
    elif index==6:
        if by<=670:             # y>670 のボールの軌跡を残す
            cvs.delete("BALL")
        bx=bx-5
        by=a*(bx-b)*(bx-b)+30
        draw_ball()
        cvs.delete("RACKET2")
        key_in2()
        draw_rakt2()
        if bx>nx-30 and bx<nx+30 and by>ny-10 and by<ny:
            b=2*bx-b
        if by>675 and by<685:       # 的に当たったときのポイント
            x1=bx
            if x1>=100 and x1<=400:
                point=1
            if x1>=150 and x1<=350:
                point=2
            if x1>=190 and x1<=310:
                point=3
            if x1>=230 and x1<=270:
                point=5            
        if by>=1200:
            tmr=0
            index=7
        else:           
            tmr=0
            index=5
    elif index==7:
        draw_text("Point: "+str(point),300,640,40,"pink","POINT")
        if jun==0:
            jun=1
            p1=p1+point
        else:
            jun=0    
            p2=p2+point
        tmr=0
        cvs.delete("pt")
        draw_point() 
        index=8
    elif index==8:
        if tmr==200:
            cvs.delete("SIKI")
            cvs.delete("RACKET2")
            cvs.delete("BALL")
            index=0        

    tmr=tmr+1    
    root.after(10,main_proc)       # root.after 2->10  ★★ スピード ★★
# =========================================================================================
    
root=tkinter.Tk()
root.title("放物線")
root.bind("<KeyPress>",key_down)
root.bind("<KeyRelease>",key_up)
cvs=tkinter.Canvas(width=1200,height=700,bg="green")    # Canvas:1200x700
# img_bg=tkinter.Image(file="bg_rakka.png")      # pg_rakka.png
# cvs.create_image(177,309,image=img_bg)      # :177,309
# cvs.create_line(43,97+53*end_l,312,97+53*end_l,fill="red",width=2)   # 水平線（上から）
cvs.pack()                
#img_mato=tkinter.PhotoImage(file="mato_1.png")       
main_proc()
root.mainloop()

